//----------------------------------------------------------------------//
// NyanFi																//
//  g̓{bNX													//
//  JgXg̒ɕ\											//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <algorithm>
#include "UserFunc.h"
#include "UserMdl.h"
#include "InpExDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TInputExDlg *InputExDlg;

//---------------------------------------------------------------------------
__fastcall TInputExDlg::TInputExDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TInputExDlg::FormCreate(TObject *Sender)
{
	IpuntExMode = 0;
	CustomWidth = 0;

	set_ComboBox_AutoComp(this);
	InputComboBox->Tag = CBTAG_HISTORY;

	for (int i=0; i<MAX_SAVE_CODEPAGES; i++) CodePageComboBox->Items->Add(SaveCodePages[i].name);
	CodePageComboBox->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TInputExDlg::FormShow(TObject *Sender)
{
	HelpTopic = EmptyStr;

	//g[h̃LvVݒ
	switch (IpuntExMode) {
	case INPEX_CRE_DIR:		 Caption = "fBNg̍쐬";	break;
	case INPEX_NEW_TEXTFILE: Caption = "VKeLXg̍쐬";	break;
	case INPEX_CLONE:		 Caption = "N[쐬";			break;
	case INPEX_CRE_TESTFILE: Caption = "eXgt@C̍쐬";	break;
	case INPEX_JUMP_LINE:	 Caption = "wsԍɈړ";		break;
	case INPEX_JUMP_ADDR:	 Caption = "wAhXɈړ";	break;
	case INPEX_SET_TOPADDR:	 Caption = "擪AhXݒ";	break;
	default:
		//CŐݒ
		;
	}

	InputEdit->Visible	   = false;
	InputComboBox->Visible = false;
	NameLabel->Visible	   = false;

	//ComboBox (t)
	if (IpuntExMode==INPEX_CRE_DIR || IpuntExMode==INPEX_NEW_TEXTFILE) {
		ClientWidth = 400;
		NameLabel->Visible	   = true;
		InputComboBox->Visible = true;
		IniFile->LoadComboBoxItems(InputComboBox,
					(IpuntExMode==INPEX_CRE_DIR)? _T("CreateDirHistory") : _T("NewTextHistory"));
		InputComboBox->Width = ClientWidth - InputComboBox->Left - ScaledInt(8);
	}
	//Edit
	else {
		InputEdit->Visible = true;
		int c_wd = ScaledInt((CustomWidth>0)? CustomWidth : InputEdit->NumbersOnly? 260 : 400);
		int l_wd = Canvas->TextWidth(InputEdit->EditLabel->Caption);
		ClientWidth = std::max(c_wd, l_wd + ScaledInt(70));
		InputEdit->Left  = l_wd + ScaledInt(12);
		InputEdit->Width = ClientWidth - InputEdit->Left - ScaledInt(8);
	}

	//\ʒu𒲐
	TPoint p;
	TRect tmp_rc = BoundsRect; tmp_rc.SetHeight(ScaledInt(120));	//***
	if (Screen->ActiveForm==Application->MainForm && StartsText("t@NVL[", Caption)) {
		int idx = (extract_int_def(InputEdit->EditLabel->Caption, 1) - 1) / 4;
		TControl *cp = Application->MainForm;
		p = cp->ClientToScreen(cp->ClientRect.CenteredRect(tmp_rc).Location);
		p.y += cp->ClientHeight/4;
		if		(idx==0) p.x -= cp->ClientWidth/3;
		else if (idx==2) p.x += cp->ClientWidth/3;
	}
	else {
		TControl *cp = (Screen->ActiveForm!=Application->MainForm)? (TControl*)Screen->ActiveForm :
										 	 (ScrMode==SCMD_FLIST)? (TControl*)FileListBox[CurListTag] :
																	(TControl*)Application->MainForm;
		p = cp->ClientToScreen(cp->ClientRect.CenteredRect(tmp_rc).Location);
	}

	TRect main_rc = Application->MainForm->BoundsRect;
	if (p.x<main_rc.Left)			 p.x = main_rc.Left + 8;
	if ((p.x + Width)>main_rc.Right) p.x = main_rc.Right - Width - 8;
	Left = p.x;
	Top  = p.y;

	NewTextPanel->Visible  = false;
	CreDirPanel->Visible   = false;
	CreTestPanel->Visible  = false;
	IniSttPanel->Visible   = false;
	NotationPanel->Visible = false;

	int hi = InputPanel->Height;
	if (IpuntExMode==INPEX_CRE_DIR) {
		DirChgCheckBox->Checked = CreDirChg;
		CnvChCheckBox->Checked	= CreDirCnvChar;
		CreDirPanel->Visible	= true;
		hi += CreDirPanel->Height;
		if (!InputComboBox->Text.IsEmpty()) {
			SelDefCheckBox->Checked = IniFile->ReadBoolGen(_T("CreDirIniSel"));
			IniSttPanel->Visible	= true;
		}
		HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_FL) _T("#CreateDir"));
	}
	else if (IpuntExMode==INPEX_NEW_TEXTFILE) {
		CodePageComboBox->ItemIndex = IniFile->ReadIntGen(_T("NewTextCodePage"));
		ClipCheckBox->Checked = IniFile->ReadBoolGen(_T("NewTextClip"));
		EditCheckBox->Checked = EditNewText;
		NewTextPanel->Visible = true;
		hi += NewTextPanel->Height;
		HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_FL) _T("#NewTextFile"));
	}
	else if (IpuntExMode==INPEX_CLONE) {
		SelDefCheckBox->Checked = IniFile->ReadBoolGen(_T("CloneIniSel"));
		IniSttPanel->Visible	= true;
		HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_FL) _T("#Clone"));
	}
	else if (IpuntExMode==INPEX_CRE_TESTFILE) {
		InputEdit->Text    = IniFile->ReadStrGen(_T("CreTestFileName"));
		TestSizeEdit->Text = IniFile->ReadStrGen(_T("CreTestFileSize"), "1M");
		TestCntEdit->Text  = "1";
		CreTestPanel->Visible = true;
		hi += CreTestPanel->Height;
		HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_FL) _T("#CreateTestFile"));
	}
	else if (IpuntExMode==INPEX_JUMP_ADDR || IpuntExMode==INPEX_SET_TOPADDR) {
		InputEdit->Text = EmptyStr;
		if (IniFile->ReadBoolGen(_T("HexAddress"), true))
			HexRadioBtn->Checked = true;
		else
			DecRadioBtn->Checked = true;
		NotationPanel->Visible = true;

		if (IpuntExMode==INPEX_JUMP_ADDR)
			HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_TV) _T("#JumpLine"));
		else
			HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_TV) _T("#SetTopAddr"));
	}
	else if (IpuntExMode==INPEX_JUMP_LINE) {
		HelpTopic.cat_sprintf(_T("%s"), _T(HELPTOPIC_TV) _T("#JumpLine"));
	}

	hi += BottomPanel->Height;
	ClientHeight = hi;

	::PostMessage(Handle, WM_FORM_SHOWED, 0, 0);
}

//---------------------------------------------------------------------------
void __fastcall TInputExDlg::WmFormShowed(TMessage &msg)
{
	if (InputEdit->Visible) {
		InputEdit->SetFocus();
		if (!InputEdit->Text.IsEmpty()) {
			if (SameText(Caption, LoadUsrMsg(USTR_Rename))) {
				int p = pos_r(_T("."), InputEdit->Text) - 1;
				if (p<0) p = InputEdit->Text.Length();
				switch (IniFile->ReadIntGen(_T("RenameDlgIniStt"))) {
				case 1:
					InputEdit->SelStart = 0;
					break;
				case 2:
					InputEdit->SelStart  = 0;
					InputEdit->SelLength = p;
					break;
				case 3:
					InputEdit->SelectAll();
					break;
				default:
					InputEdit->SelStart = p;
				}
			}
			else {
				if (IniSttPanel->Visible && SelDefCheckBox->Checked)
					InputEdit->SelectAll();
				else
					InputEdit->SelStart = InputEdit->Text.Length();
			}
		}
	}
	else if (InputComboBox->Visible) {
		InputComboBox->SetFocus();
		if (InputComboBox->Text.IsEmpty()) {
			if (IniSttPanel->Visible && SelDefCheckBox->Checked)
				InputComboBox->SelectAll();
			else
				InputComboBox->SelStart = InputComboBox->Text.Length();
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TInputExDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	CloseIME(Handle);

	//̕ۑ
	if (ModalResult==mrOk && (IpuntExMode==INPEX_CRE_DIR || IpuntExMode==INPEX_NEW_TEXTFILE)) {
		add_ComboBox_history(InputComboBox, InputComboBox->Text);
		IniFile->SaveComboBoxItems(InputComboBox,
					(IpuntExMode==INPEX_CRE_DIR)? _T("CreateDirHistory") : _T("NewTextHistory"));
	}

	//̑̃IvV̕ۑ
	if (IpuntExMode==INPEX_CRE_DIR) {
		CreDirChg	  = DirChgCheckBox->Checked;
		CreDirCnvChar = CnvChCheckBox->Checked;
	}
	else if (IpuntExMode==INPEX_NEW_TEXTFILE) {
		IniFile->WriteIntGen(_T("NewTextCodePage"),	CodePageComboBox);
		IniFile->WriteBoolGen(_T("NewTextClip"),	ClipCheckBox);
		EditNewText = EditCheckBox->Checked;
	}
	else if (IpuntExMode==INPEX_CRE_TESTFILE) {
		IniFile->WriteStrGen(_T("CreTestFileName"),	InputEdit->Text);
		IniFile->WriteStrGen(_T("CreTestFileSize"),	TestSizeEdit->Text);
	}
	else if (IpuntExMode==INPEX_JUMP_ADDR || IpuntExMode==INPEX_SET_TOPADDR) {
		IniFile->WriteBoolGen(_T("HexAddress"),		HexRadioBtn->Checked);
		UnicodeString lbuf = Trim(InputEdit->Text);
		if (HexRadioBtn->Checked) {
			//16ȉꍇA0x t
			if (!lbuf.IsEmpty()) lbuf.Insert("0x", starts_tchs(_T("+-"), lbuf)? 2 : 1);
		}
		InputEdit->Text = lbuf;
	}

	if (IniSttPanel->Visible) {
		switch (IpuntExMode) {
		case INPEX_CLONE:	IniFile->WriteBoolGen(_T("CloneIniSel"),  SelDefCheckBox); break;
		case INPEX_CRE_DIR:	IniFile->WriteBoolGen(_T("CreDirIniSel"), SelDefCheckBox); break;
		}
	}

	IpuntExMode = 0;
	CustomWidth = 0;
	InputEdit->NumbersOnly = false;
}

//---------------------------------------------------------------------------
void __fastcall TInputExDlg::OptionClick(TObject *Sender)
{
	if		(InputEdit->Visible)	 InputEdit->SetFocus();
	else if (InputComboBox->Visible) InputComboBox->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TInputExDlg::SelDefCheckBoxClick(TObject *Sender)
{
	if (InputEdit->Visible) {
		InputEdit->SetFocus();
		if (IniSttPanel->Visible && SelDefCheckBox->Checked)
			InputEdit->SelectAll();
		else
			InputEdit->SelStart = InputEdit->Text.Length();
	}
	else if (InputComboBox->Visible) {
		InputComboBox->SetFocus();
		if (IniSttPanel->Visible && SelDefCheckBox->Checked)
			InputComboBox->SelectAll();
		else
			InputComboBox->SelStart = InputComboBox->Text.Length();
	}
}

//---------------------------------------------------------------------------
void __fastcall TInputExDlg::InputEditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialEditProc(Sender, Key, Shift);
}
//---------------------------------------------------------------------------
void __fastcall TInputExDlg::InputEditKeyPress(TObject *Sender, System::WideChar &Key)
{
	if (is_KeyPress_CtrlNotCV(Key)) Key = 0;
}

//---------------------------------------------------------------------------
void __fastcall TInputExDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (equal_F1(get_KeyStr(Key, Shift)) && !HelpTopic.IsEmpty()) {
		HtmlHelpTopic(HelpTopic.c_str());
		Key = 0;
	}
}
//---------------------------------------------------------------------------

